'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactUikitBase = require('react-uikit-base');

var _reactUikitBase2 = _interopRequireDefault(_reactUikitBase);

var _ufunc = require('ufunc');

var _ufunc2 = _interopRequireDefault(_ufunc);

var _badge = require('../../react-uikit-badge/lib/badge');

var _badge2 = _interopRequireDefault(_badge);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ListItem = (function (_React$Component) {
  _inherits(ListItem, _React$Component);

  function ListItem() {
    _classCallCheck(this, ListItem);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(ListItem).apply(this, arguments));
  }

  _createClass(ListItem, [{
    key: 'handelLinkClick',
    value: function handelLinkClick(e) {
      e.preventDefault(e);
      this.props.onClick({ event: e, kitid: this.props.kitid });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var $props = this.props;

      // CSS classes
      var cssClassNames = _reactUikitBase2.default.helpers.cleanClasses([$props.active ? 'uk-active' : null, $props.classes, $props.className]);

      // Elements
      var badge = _ufunc2.default.maybeIf(_react2.default.createElement(_badge2.default, {
        floats: 'right',
        body: $props.badge ? $props.badge.body : null,
        context: $props.badge ? $props.badge.context : null,
        notification: $props.badge ? $props.badge.notification : null
      }))($props.badge);

      var link = _react2.default.createElement(
        'li',
        _extends({}, $props, {
          className: cssClassNames }),
        _react2.default.createElement(
          'a',
          {
            'data-kitid': $props.kitid,
            href: $props.href,
            className: $props.active ? 'uk-active' : null,
            onClick: function onClick(e) {
              return _this2.handelLinkClick(e);
            }
          },
          $props.selectable,
          ' ',
          $props.body,
          ' ',
          badge
        )
      );

      var text = _react2.default.createElement(
        'li',
        _extends({}, $props, {
          className: cssClassNames,
          onClick: $props.onClick,
          'data-kitid': $props.kitid
        }),
        $props.selectable,
        ' ',
        $props.body
      );

      // Return Component
      var component = _ufunc2.default.either(link, text);
      return component($props.href);
    }
  }]);

  return ListItem;
})(_react2.default.Component);

ListItem.propTypes = {
  active: _react2.default.PropTypes.bool,
  badge: _react2.default.PropTypes.object,
  body: _react2.default.PropTypes.string,
  href: _react2.default.PropTypes.string,
  onClick: _react2.default.PropTypes.func,
  selectable: _react2.default.PropTypes.bool
};
exports.default = _reactUikitBase2.default.base(ListItem);